--returns the pattern command text for device number
----------------------------------------------------------
function get_devices_patternfx_num_or_letter(device_index)
----------------------------------------------------------
  
  if device_index < 10 then
    return tostring(device_index)
  elseif device_index == 10 then
    return "A"
  elseif device_index == 11 then
    return "B"
  elseif device_index == 12 then
    return "C"
  elseif device_index == 13 then
    return "D"
  elseif device_index == 14 then
    return "E"
  elseif device_index == 15 then
    return "F"
  elseif device_index == 16 then
    return "G"
  elseif device_index == 17 then
    return "H"
  elseif device_index == 18 then
    return "I"
  elseif device_index == 19 then
    return "J"
  elseif device_index == 20 then
    return "K"
  elseif device_index == 21 then
    return "L"
  elseif device_index == 22 then
    return "M"
  elseif device_index == 23 then
    return "N"
  elseif device_index == 24 then
    return "O"
  elseif device_index == 25 then
    return "P"
  elseif device_index == 26 then
    return "Q"
  elseif device_index == 27 then
    return "R"
  elseif device_index == 28 then
    return "S"
  elseif device_index == 29 then
    return "T"
  elseif device_index == 30 then
    return "U"
  elseif device_index == 31 then
    return "V"
  elseif device_index == 32 then
    return "W"
  elseif device_index == 33 then
    return "X"
  elseif device_index == 34 then
    return "Y"
  end
  --renoise pattern commands 'only' go to 34 devices
  return nil
end




-------------------------------------------------------
function go_to_previous_col_fx_bypass_selected_device()
-------------------------------------------------------
 
  local song = renoise.song()
  local sel_dev_idx = song.selected_device_index - 1
  
  if sel_dev_idx == 0 then
    status("No Bypassable Device Chosen In Renoise")
    return
  end
  
  --get hex format of device_index
  local dev_idx_str = get_devices_patternfx_num_or_letter(sel_dev_idx)
  
  if dev_idx_str == nil then
    error("Not A Valid Device Index")
    return
  end
  
  local trk_idx = song.selected_track_index
  local pat_seq = song.sequencer.pattern_sequence
  local max_cols = renoise.InstrumentPhrase.MAX_NUMBER_OF_EFFECT_COLUMNS
  local seq_idx = song.selected_sequence_index
  local sel_line_idx = song.selected_line_index
  
  local counter = 1
  local bp_tab = {}
  

  
  --loop all patterns available in sequencer (we don't need hidden/ unused patterns)
  for i = seq_idx ,1,-1 do
    
    local pat_idx = song.sequencer:pattern(i)
   
    if sel_line_idx == 1 then
      if (pat_idx - 1) ~= 0 then 
        sel_line_idx = #song:pattern(pat_idx-1):track(trk_idx).lines
      end
    else
      local cur_pat_trk = song:pattern(pat_idx):track(trk_idx)
      if cur_pat_trk.is_empty == false then
        --loop lines in pattern
        for lines = sel_line_idx-1, 1,-1 do
          local cur_line = cur_pat_trk:line(lines)
          if cur_line.is_empty == false then
            --loop columns in line
            for fx_cols = 1,max_cols do
              --if acks[].lines[].effect_columns[].is_empty
              local cur_col = cur_line:effect_column(fx_cols)
              if cur_col.is_empty == false then
                local num_string = cur_col.number_string
                local fx_string = cur_col.amount_string
                local first_num_str = string.sub(num_string,1,1)
                local second_num_str = string.sub(num_string,2,2)
                --check for bypass command for specified device_index
                if (first_num_str == dev_idx_str) and (second_num_str == "0") then --bypass command == 'X000' or 'X001'
                  song.selected_sequence_index = i
                  song.selected_line_index = lines
                  if fx_string == "00" then
                    status("OFF Command")
                  else
                    status("ON Command")
                  end
                  return
                end 
              end
            end
         end
        end
      end
    end--pat empty  
  end 
  status("No Further Previous FX Bypass Found")
end

-------------------------------------------------------
function go_to_next_col_fx_bypass_selected_device()
-------------------------------------------------------
 
  local song = renoise.song()
  local sel_dev_idx = song.selected_device_index - 1
  
  if sel_dev_idx == 0 then
    status("No Bypassable Device Chosen In Renoise")
    return
  end
  
  --get hex format of device_index
  local dev_idx_str = get_devices_patternfx_num_or_letter(sel_dev_idx)
  
  if dev_idx_str == nil then
    error("Not A Valid Device Index")
    return
  end
  
  local trk_idx = song.selected_track_index
  local pat_seq = song.sequencer.pattern_sequence
  local max_cols = renoise.InstrumentPhrase.MAX_NUMBER_OF_EFFECT_COLUMNS
  local seq_idx = song.selected_sequence_index
  local sel_line_idx = song.selected_line_index
  
  local counter = 1
  local bp_tab = {}
  
  
  --loop all patterns available in sequencer (we don't need hidden/ unused patterns)
  for i = seq_idx ,#pat_seq do
   -- print(#pat_seq)
    local pat_idx = song.sequencer:pattern(i)
    
    if i > seq_idx then
      sel_line_idx = 0
    end
  
    local cur_pat_trk = song:pattern(pat_idx):track(trk_idx)
    if cur_pat_trk.is_empty == false then
      --loop lines in pattern
      for lines = sel_line_idx + 1, #cur_pat_trk.lines do
        local cur_line = cur_pat_trk:line(lines)
        if cur_line.is_empty == false then
          --loop columns in line
          for fx_cols = 1,max_cols do
            --if acks[].lines[].effect_columns[].is_empty
            local cur_col = cur_line:effect_column(fx_cols)
            if cur_col.is_empty == false then
              local num_string = cur_col.number_string
              local fx_string = cur_col.amount_string
              local first_num_str = string.sub(num_string,1,1)
              local second_num_str = string.sub(num_string,2,2)
              --check for bypass command for specified device_index
              if (first_num_str == dev_idx_str) and (second_num_str == "0") then --bypass command == 'X000' or 'X001'
                song.selected_sequence_index = i
                song.selected_line_index = lines
                if fx_string == "00" then
                  status("OFF Command")
                else
                  status("ON Command")
                end
                return
              end 
            end
          end
        end
      end
    end--pat empty  
  end 
  status("No Further FX Bypass Found")
end

--[[
--device index counts from 1 (mixer is --/ 0)
------------------------------------------------------------------------
function get_all_bypass_commands_in_track_for_device(track,device_index)
------------------------------------------------------------------------
  
  --get hex format of device_index
  local dev_idx_str = get_devices_patternfx_num_or_letter(device_index)
  
  if dev_idx_str == nil then
    error("Not A Valid Device Index")
    return
  end

  local song = renoise.song()
  local trk_idx = track
  local pat_seq = song.sequencer.pattern_sequence
  local max_cols = renoise.InstrumentPhrase.MAX_NUMBER_OF_EFFECT_COLUMNS
  
  local counter = 1
  local bp_tab = {}
  
  
  --loop all patterns available in sequencer (we don't need hidden/ unused patterns)
  for i = 1,#pat_seq do
   -- renoise.song().patterns[].tracks[].lines[].effect_columns[]
    local pat_idx = song.sequencer:pattern(i)
    local cur_pat_trk = song:pattern(pat_idx):track(trk_idx)
    if cur_pat_trk.is_empty == false then
      --loop lines in pattern
      for lines = 1, #cur_pat_trk.lines do
        local cur_line = cur_pat_trk:line(lines)
        if cur_line.is_empty == false then
          --loop columns in line
          for fx_cols = 1,max_cols do
            --if acks[].lines[].effect_columns[].is_empty
            local cur_col = cur_line:effect_column(fx_cols)
            if cur_col.is_empty == false then
              local num_string = cur_col.number_string
              local fx_string = cur_col.amount_string
              local first_num_str = string.sub(num_string,1,1)
              local second_num_str = string.sub(num_string,2,2)
              --check for bypass command for specified device_index
              if (first_num_str == dev_idx_str) and (second_num_str == "0") then --bypass command == 'X000' or 'X001'
                --print("here")
                bp_tab[counter] = {}
                bp_tab[counter].sequencer_index = i 
                bp_tab[counter].line_index = lines 
                if string.sub(fx_string,2,2) == "0" then
                  bp_tab[counter].state = "OFF"
                else
                  bp_tab[counter].state = "ON"
                end
                counter = counter + 1
              end 
            end
          end
        end
      end
    end--pat empty  
  end 
  return bp_tab
end 

-------------------------------------------------------
function get_items_for_bypass_popup(track,device_index)
-------------------------------------------------------
 local song = renoise.song()
 
 local bp_tab = get_all_bypass_commands_in_track_for_device(track,device_index)
 
 local items = {}
 
 for i = 1,#bp_tab do
   local item_string = "Seq: "..tostring(bp_tab[i].sequencer_index-1).." --> Line: "..tostring(bp_tab[i].line_index-1)..": "..bp_tab[i].state
   items[i] = {}
   items[i].item_string = item_string
   items[i].sequencer_index = bp_tab[i].sequencer_index
   items[i].line_index = bp_tab[i].line_index
  -- print(items[i])
 end
 
 return items

end
--]]


